; screen.move() method

%INCLUDE "../defines/kernel.inc"
%INCLUDE "object.def"


%define __y [ebp+__input_value+8]		; cursor y position
%define __x [ebp+__input_value+4]		; cursor x position
%define __nr_inputs [ebp+__input_value]


[section .text]
[org 0h]
[bits 32]
move:

	; check inputs
		cmp dword __nr_inputs,2
		je .ok

		MRET_FAIL

		.ok:

	; set new cursor location
		mov edx,__object
		mov bh,__x
		mov bl,__y
		mov [edx+object_y],bx

	; get cursor location
		xor eax,eax		; eax is zero on thread entry
		mov al,80
		mul bl
		mov bl,bh
		and ebx,0ffh
		add eax,ebx
		mov ebx,eax

	; move hardware cursor
		mov dx,3d4h	; address port
		mov al,0fh	; select register 15
		out dx,al

		mov eax,ebx

		inc dx		; register port
		out dx,al
		dec dx		; address port
		mov al,0eh	; select register 14
		out dx,al
		inc dx		; register port
		mov al,ah
		out dx,al


	MRET_OK	
